/**
 * Project Salmon (Habbo Hotel r63b Emulator)
 *
 * Copyright (c) 2013 - 2014, Jacob Pollack.
 **
 * SVN: svn://jamach.servehttp.com/projectSalmon
 **
 */

#ifndef __SALMON_DATA_CONFIGDATA_H
#define __SALMON_DATA_CONFIGDATA_H

#include <map>

class ConfigData {
  private:
    // Stores the configuration data.
    std::map<char *, char *, bool (*)(char * const, char * const)> data;
  public:
    // Constructs a ConfigData object. Open the specified file and parses it, 
    // loading the configuration data into the data map.
    explicit ConfigData(const char * const);
    // Destructs a ConfigData object.
    ~ConfigData();
  private:
    // Disables the copy constructor.
    explicit ConfigData(const ConfigData &);
    // Disables the assignment operator.
    ConfigData &operator=(const ConfigData &);
  public:
    // Gets the configuration data at a specific key.
    char *operator[](const char * const);
};

#endif