/**
 * Project Salmon (Habbo Hotel r63b Emulator)
 *
 * Copyright (c) 2013 - 2014, Jacob Pollack.
 **
 * SVN: svn://jamach.servehttp.com/projectSalmon
 **
 */

#ifndef __SALMON_EXCEPTIONS_CRITEXCEPTION_H
#define __SALMON_EXCEPTIONS_CRITEXCEPTION_H

#include <exception>
#include <string>

// :NOTE: This class cannot be subclassed.
class CritException : public std::exception {
  private:
    // Stores the exception message.
    std::string message;
  public:
    // Constructs a CritException object.
    CritException(const std::string, const int, const std::string) throw();
    // Destructs a CritException object.
    ~CritException() throw();
  private:
    // Disables the assignment operator.
    CritException &operator=(const CritException &);
  public:
    // Gets the exception message.
    const char *what() const throw();
};

#endif