/**
 * Project Salmon (Habbo Hotel r63b Emulator)
 *
 * Copyright (c) 2013 - 2014, Jacob Pollack.
 **
 * SVN: svn://jamach.servehttp.com/projectSalmon
 **
 */

#ifndef __SALMON_NET_SESSION_H
#define __SALMON_NET_SESSION_H

class Session {
  private:
    // Stores the Session's unique file descriptor.
    const int fileDes;
  public:
    // Constructs a Session object.
    explicit Session(const int);
    // Destructs a Session object.
    ~Session();
  private:
    // Disables the copy constructor.
    explicit Session(const Session &);
    // Disables the assignment operator.
    Session &operator=(const Session &);
  public:
    // Gets the Session's file descriptor.
    int getFileDes() const;
  public:
    // Determines if the Session is still alive.
    bool isAlive();
};

#endif
