/**
 * Project Salmon (Habbo Hotel r63b Emulator)
 *
 * Copyright (c) 2013 - 2014, Jacob Pollack.
 **
 * SVN: svn://jamach.servehttp.com/projectSalmon
 **
 */

#ifndef __SALMON_NET_SOCKETMANAGER_H
#define __SALMON_NET_SOCKETMANAGER_H

#include <string>

// Forward declaration of classes.
class ConnectionReactor;

class SocketManager {
  private:
    // Stores the server socket's file descriptor.
    int serverFD;
    // Stores the ConnectionReactor (owns-a).
    ConnectionReactor *connectionReactor;
  public:
    // Constructs a SocketManager. Creates a socket and binds it to the 
    // specified IP address and port. Marks the socket as accepting incoming 
    // connections.
    SocketManager(const std::string, const short, const short);
    // Destructs a SocketManager.
    ~SocketManager();
  private:
    // Disables the copy constructor.
    explicit SocketManager(const SocketManager &);
    // Disables the assignment operator.
    SocketManager &operator=(const SocketManager &);
  public:
    // Gets the ConnectioNReactor object.
    ConnectionReactor &getConnectionReactor() const;
};

#endif