/**
 * Project Salmon (Habbo Hotel r63b Emulator)
 *
 * Copyright (c) 2013 - 2014, Jacob Pollack.
 **
 * SVN: svn://jamach.servehttp.com/projectSalmon
 **
 */

#ifndef __SALMON_SALMON_H
#define __SALMON_SALMON_H

// Forward declaration of classes.
class ConfigData;
class ThreadPool;
class SocketManager;

class Salmon {
  private:
    // Stores the Salmon object.
    static Salmon *instance;
  private:
    // Stores the ConfigData object.
    ConfigData *configData;
    // Stores the ThreadPool object.
    ThreadPool *threadPool;
    // Stores the SocketManager object.
    SocketManager *socketManager;
  public:
    // Constructs a Salmon object. Initializes all of the core objects.
    Salmon();
    // Destructs a Salmon object. Cleans up the core objects and game 
    // environment.
    ~Salmon();
  public:
    // Disables the copy constructor.
    explicit Salmon(const Salmon &);
    // Disables the assignment operator.
    Salmon &operator=(const Salmon &);
  public:
    // Gets the Salmon object.
    static Salmon &getInstance();
  public:
    // Gets the ConfigData object.
    ConfigData &getConfigData() const;
    // Gets the ThreadPool object.
    ThreadPool &getThreadPool() const;
    // Gets the SocketManager object.
    SocketManager &getSocketManager() const;
  public:
    // Runs the game environment.
    void run();
};

// Declares a global variable, salmon, that is an instance of Salmon.
extern Salmon &salmon;

#endif