/**
 * Project Salmon (Habbo Hotel r63b Emulator)
 *
 * Copyright (c) 2013 - 2014, Jacob Pollack.
 **
 * SVN: svn://jamach.servehttp.com/projectSalmon
 **
 */

#ifndef __unix__
#define OS_UNIX 1
#else
#define OS_UNIX 0
#endif

#include "salmon.h"

#include <cstdlib> // exit, atexit

// Shuts down the game environment gracefully.
void shutdown();

// Starts the main game environment, salmon.
int main() {
  try {
    // Determines if we are running under a UNIX-based OS. If so, start the 
    // main game environment, otherwise exit the process with an error code.
    if (true == OS_UNIX) {
      // Binds the shutdown function.
      const int result = atexit(&shutdown);

      // Determines if an error occurred binding the shutdown function. If so, 
      // run the game, otherwise exit the process with an error code.
      if (0 == result) {
        // Runs the game environment.
        salmon.run();
      } else {
        exit(EXIT_FAILURE); // :TODO: Determine a specific error code.
      }
    } else {
      exit(EXIT_FAILURE); // :TODO: Determine a specific error code.
    }
  // Catches all exceptions that are critical to the game environment.
  // :TODO: Log these critical exceptions.
  } catch (...) { }

  return 0;
}

// See declaration above.
void shutdown() {
  delete &salmon;
}